/*
    JSiteMap 0.8.1 - A Java Site Map Generator
    Copyright (C) 2003 Pierre Blanc
    Pierre Blanc: blanc_teutoburgo@yahoo.it
    http://www.site-map.tk
    http://it.geocities.com/teutoburgo

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    or go to      http://www.gnu.org/copyleft/gpl.html
*/

package tk.teutoburgo.jsitemap;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;

/**
 * <p>Title: Java Site Map Generator</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: www.site-map.tk</p>
 * @author Pierre Blanc
 * @version 0.8.1
 */

public class JSiteMapApplet extends Applet {
    Parser parser = null;
    ScriptGenerator sg=new ScriptGenerator();
    private String startTag="<A name=sitemap>", hrefTag="",
	hrefEndTag="</A>", startListTag="<UL>", endListTag="</UL>",
	listItemTag="<LI>", endListItemTag="</LI>",
	htmlCode="", endURLTag="",
	STOPTag="", memory="", SHOW="Show license";
    boolean isStandalone = false, showLicense=true;
    int rows=9, cols=60;
    BorderLayout borderLayout1 = new BorderLayout();
    Panel centerPanel = new Panel();
    TextArea textArea1 = new TextArea("",rows,cols,
        TextArea.SCROLLBARS_VERTICAL_ONLY);
    TextArea textArea2 = new TextArea("",rows,cols);
    Panel panelEast = new Panel();
    Button button1 = new Button();
    Button button2 = new Button();
    Button buttonLicense = new Button();
    Panel panel1 = new Panel();
    Panel panelInfo = new Panel();
    Panel panelStatus = new Panel();
    GridLayout gridLayout1 = new GridLayout();
    Panel panelNorth = new Panel();
    Label label1 = new Label();
    Label label2 = new Label();
    Label labelAuthor = new Label();
    Label labelTitle = new Label();
    GridLayout gridLayout2 = new GridLayout();
    //Get a parameter value
    public String getParameter(String key, String def) {
	return isStandalone ? System.getProperty(key, def) :
	    (getParameter(key) != null ? getParameter(key) : def);
    }

    //Construct the applet
    public JSiteMapApplet() {
    }
    //Initialize the applet
    public void init() {
	try {
	    if(!isStandalone){
		startTag=getParameter("startTag");
		hrefTag=getParameter("hrefTag");
		hrefEndTag=getParameter("hrefEndTag");
		startListTag=getParameter("startListTag");
		endListTag=getParameter("endListTag");
		listItemTag=getParameter("listItemTag");
		endListItemTag=getParameter("endListItemTag");
		endURLTag=getParameter("endURLTag");
		STOPTag=getParameter("STOPTag");
		htmlCode=getParameter("htmlCode");
	    }else{
		Properties p=new Properties();
		FileInputStream fis=new FileInputStream(
                    "../config/JSiteMap.cfg");
		p.load(fis);
		startTag=p.getProperty("startTag");
		hrefTag=p.getProperty("hrefTag");
		hrefEndTag=p.getProperty("hrefEndTag");
		startListTag=p.getProperty("startListTag");
		endListTag=p.getProperty("endListTag");
		listItemTag=p.getProperty("listItemTag");
		endListItemTag=p.getProperty("endListItemTag");
		endURLTag=p.getProperty("endURLTag");
		STOPTag=p.getProperty("STOPTag");
		htmlCode=p.getProperty("htmlCode");
	    }
	    jbInit();
	    // System.out.println("tag="+hrefTag);
	    parser = new Parser(startTag, hrefTag, hrefEndTag,
				startListTag, endListTag, listItemTag,
				endListItemTag, endURLTag, STOPTag);
	}
	catch(Exception e) {
	    e.printStackTrace();
	}
    }
    //Component initialization
    private void jbInit() throws Exception {
	this.setLayout(borderLayout1);
	/*    textArea1.setColumns(50);
	      textArea1.setRows(7);
	      textArea2.setColumns(50);
	      textArea2.setRows(7);*/
	textArea1.setText(htmlCode);
	button1.setLabel("Generate");
	button1.addMouseListener(new java.awt.event.MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
		    button1_mouseClicked(e);
		}
	    });
	button2.setLabel("Clear all");
	button2.addMouseListener(new java.awt.event.MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
		    button2_mouseClicked(e);
		}
	    });
	buttonLicense.setLabel(SHOW);
	buttonLicense.addMouseListener(new java.awt.event.MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
		    buttonLicense_mouseClicked(e);
		}
	    });
	panelEast.setLayout(gridLayout1);
	gridLayout1.setColumns(1);
	gridLayout1.setRows(5);
	label1.setText("Insert HTML map code and press \'Generate\'");
	label2.setText("Copy generated javascript code into .js file");
	//    labelLicense.setText("This software is under the GNU GPL license v.2");
	labelAuthor.setText("Copyright (C) P.Blanc 2003 - blanc_teutoburgo"+
            "@yahoo.it - http://www.site-map.tk");
	labelTitle.setText("JSiteMap 0.8.4 - Java Site Map Generator");
	panelNorth.setLayout(gridLayout2);
	gridLayout2.setColumns(1);
	gridLayout2.setRows(2);
	centerPanel.add(label1, null);
	this.add(centerPanel, BorderLayout.CENTER);
	centerPanel.add(textArea1, null);
	this.add(panelEast,  BorderLayout.EAST);
	panelEast.add(panel1, null);
	panelEast.add(button1, null);
	panelEast.add(button2, null);
	panelStatus.setBackground(Color.lightGray);
	panelEast.add(panelStatus, null);
	this.add(panelNorth, BorderLayout.NORTH);
	panelInfo.add(labelTitle, null);
	panelInfo.add(buttonLicense, null);
	panelNorth.add(panelInfo, null);
	panelNorth.add(labelAuthor, null);
	centerPanel.add(label2, null);
	centerPanel.add(textArea2, null);
    }
    //Start the applet
    public void start() {
    }
    //Stop the applet
    public void stop() {
    }
    //Destroy the applet
    public void destroy() {
    }
    //Get Applet information
    public String getAppletInfo() {
	return "Applet Information";
    }
    //Get parameter info
    public String[][] getParameterInfo() {
	return null;
    }
    //Main method
    public static void main(String[] args) {
	JSiteMapApplet applet = new JSiteMapApplet();
	applet.isStandalone = true;
	Frame frame;
	frame = new Frame() {
		protected void processWindowEvent(WindowEvent e) {
		    super.processWindowEvent(e);
		    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			System.exit(0);
		    }
		}
		public synchronized void setTitle(String title) {
		    super.setTitle(title);
		    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		}
	    };
	frame.setTitle("JSiteMap");
	frame.add(applet, BorderLayout.CENTER);
	applet.init();
	applet.start();
	frame.setSize(580,450);
	Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
	frame.setLocation((d.width - frame.getSize().width) / 2,
            (d.height - frame.getSize().height) / 2);
	frame.setVisible(true);
    }

    void button1_mouseClicked(MouseEvent e) {
	panelStatus.setBackground(Color.yellow);
	textArea2.setText("Working..");
	String htmlCode=textArea1.getText();
	//    System.out.println("-------text: "+htmlCode);
	TeutoTreeNode map=parser.parse(htmlCode);
	if(map!=null){
	    String scriptCode=sg.generate(map);
	    sg.resetNodeNumber();
	    textArea2.setText(scriptCode);
	    panelStatus.setBackground(Color.green);
	} else{
	    textArea2.setText("ERROR! Invalid input code.");
	    panelStatus.setBackground(Color.red);
	}
    }

    void button2_mouseClicked(MouseEvent e) {
	textArea1.setText("");
	textArea2.setText("");
	panelStatus.setBackground(Color.lightGray);
    }

    void buttonLicense_mouseClicked(MouseEvent e) {
	if(showLicense){
	    memory=textArea1.getText();
	    textArea1.setText("This software is under the GNU GPL license v.2. This"+
			      " product includes software developed by the Apache Software"+
			      " Foundation (http://www.apache.org/). The Javascript Tree Menu is"+
			      " copyright of Morten Wang and comes with the BSD license.");
	    buttonLicense.setLabel("Back");
	} else {
	    textArea1.setText(memory);
	    buttonLicense.setLabel(SHOW);
	}
	showLicense=!showLicense;
    }

}
